package ru.ispras.kmb.spring8;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketException;
import java.nio.charset.Charset;
import java.util.Arrays;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

public class NetworkBroker implements Broker {
	private static final int UNSUBSCRIBE_REQUEST = 2;
	private static final int SUBSCRIBE_MSG = 1;
	private static final Charset UTF8 = Charset.forName("utf-8");
	private DatagramSocket sock;
	private Worker worker;
	private Thread thread;
	
	protected class Worker implements Runnable {
		
		@Override
		public void run() {
			// TODO Auto-generated method stub
			
		}

		public int awaitSubscribeConfirmation(String topic, CountDownLatch cl) {
			// TODO Auto-generated method stub
			return 0;
		}

		public void cancel(int waitId) {
			// TODO Auto-generated method stub
			
		}

		public int awaitUnSubscribeConfirmation(String topic, CountDownLatch cl) {
			// TODO Auto-generated method stub
			return 0;
		}
		
	}

	protected NetworkBroker(InetAddress addr, int port) throws IOException  {
		sock = new DatagramSocket();
		sock.connect(addr, port);
		worker = new Worker();
		thread = new Thread(worker);
		thread.start();
	}
	public static Broker connect(InetAddress addr, int port) throws IOException {
		return new NetworkBroker(addr, port);
	}

	@Override
	public void subscribe(Subscriber s, String topic) throws IOException, TimeoutException {
		byte[] topic_bytes = topic.getBytes(UTF8);
		byte[] msg = new byte[(1 + topic_bytes.length)];
		msg[0] = SUBSCRIBE_MSG;
		for (int i = 0; i < topic_bytes.length; i++) {
			msg[i+1] = topic_bytes[i];
		}
		CountDownLatch cl = new CountDownLatch(1);
		int waitId = worker.awaitSubscribeConfirmation(topic, cl);
		try {
			sock.send(new DatagramPacket(msg, msg.length));
			cl.await(1, TimeUnit.SECONDS);
			boolean waitResult = cl.await(1, TimeUnit.SECONDS);
			if (!waitResult) {
				throw new TimeoutException("Timeout subscribe request");
			}
		} catch (InterruptedException e) {
		} finally {
			worker.cancel(waitId);
		}
	}

	@Override
	public void unsubscribe(Subscriber s, String topic) throws IOException, TimeoutException {
		byte[] topic_bytes = topic.getBytes(UTF8);
		byte[] msg = new byte[(1 + topic_bytes.length)];
		msg[0] = UNSUBSCRIBE_REQUEST;
		for (int i = 0; i < topic_bytes.length; i++) {
			msg[i+1] = topic_bytes[i];
		}
		CountDownLatch cl = new CountDownLatch(1);
		int waitId = worker.awaitUnSubscribeConfirmation(topic, cl);
		try {
			sock.send(new DatagramPacket(msg, msg.length));
			boolean waitResult = cl.await(1, TimeUnit.SECONDS);
			if (!waitResult) {
				throw new TimeoutException("Timeout unsubscribe request");
			}
		} catch (InterruptedException e) {
		} finally {
			worker.cancel(waitId);
		}
	}

	@Override
	public void publish(String topic, String msg) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public InetSocketAddress getAddress() {
		// TODO Auto-generated method stub
		return null;
	}

}
